# keywin.mak : Builds the keywin application
#
# Usage:     NMAKE option (build keywin)
#    or:     NMAKE clean  (erase all compiled files)
#
# option:    DEBUG=[0|1]  (DEBUG not defined is equivalent to DEBUG=1)

DEBUG=1

CPPFLAGS=/AM /GA /G2 /W3 
CFLAGS=/AM /GA /G2 /W3

LINKFLAGS=/STACK:10240 /ALIGN:16 /NOD /ONERROR:NOEXE /PACKC:61440

!if "$(DEBUG)" != "0"
CPPFLAGS=/D_DEBUG $(CPPFLAGS) /Od /Zi /Fdkeywin.pdb
CFLAGS=/D_DEBUG $(CFLAGS) /Od /Zi /Fdkeywin.pdb
LINKFLAGS=$(LINKFLAGS) /CODEVIEW
LIBS=mafxcwd mlibcew 
RCDEFS=/D_DEBUG
!else
CPPFLAGS=/DNDEBUG $(CPPFLAGS) /O1
CFLAGS=/DNDEBUG $(CFLAGS) /O1
LINKFLAGS=$(LINKFLAGS)
LIBS=mafxcw mlibcew 
RCDEFS=/DNDEBUG
!endif

CPPFLAGS=$(CPPFLAGS) /Yustdafx.h
LIBS=$(LIBS) libw commdlg shell

#############################################################################
# file list

OBJS=stdafx.obj keywin.obj \
	keywidoc.obj \
	skey.obj \
	keywivw.obj \
	mainfrm.obj \
	minksubr.obj \
	md4.obj \
	put.obj
	# TODO: add more files here

#############################################################################
# Final linking

keywin.exe: $(OBJS) keywin.def keywin.res
	link @<<
$(OBJS)
keywin.exe
keywin.map/MAP
$(LIBS)
keywin.def $(LINKFLAGS)
;
<<
	rc /t keywin.res
	mapsym keywin.map

#############################################################################
# Compiling resources

keywin.res: resource.h keywin.rc res\*.*
	rc /r /z $(RCDEFS) keywin.rc

#############################################################################
# Special rules

# 'stdafx.pch' contains pre-compiled header
# 'stdafx.obj' to contain pre-compiled types
stdafx.obj stdafx.pch: stdafx.h
	$(CPP) $(CPPFLAGS) /Ycstdafx.h /c stdafx.cpp

*.obj: stdafx.pch

# Note: no explicit dependency on resource.h
keywin.obj: keywin.h mainfrm.h \
	keywidoc.h \
	keywivw.h

skey.obj: md4.h mink.h

minksubr.obj: md4.h mink.h

md4.obj: md4.h mink.h

put.obj: md4.h

mainfrm.obj: keywin.h mainfrm.h

keywidoc.obj: keywin.h \
	keywidoc.h

keywivw.obj: keywin.h \
	keywidoc.h \
	mink.h \
	keywivw.h

clean:
	-erase keywin.exe
	-erase keywin.res
	-erase stdafx.pch
	-erase keywin.map
	-erase keywin.sym
	-erase keywin.pdb
	-erase *.obj

#############################################################################
